# TelegramQt5Config.cmake is generated by CMake from TelegramQtConfig.cmake.in.
# Any changed value in this file will be overwritten by CMake.

if(CMAKE_VERSION VERSION_LESS 3.6)
    message(FATAL_ERROR "TelegramQt requires at least CMake version 3.6")
endif()

# Valid modules: Core, Qml
set(_WANTED_COMPONENTS "${TelegramQt5_FIND_COMPONENTS}")
if (NOT Core IN_LIST _WANTED_COMPONENTS)
    list(INSERT _WANTED_COMPONENTS 0 Core)
endif()

# Find dependencies
include(CMakeFindDependencyMacro)

# Base Qt components set
set(_QT_COMPONENTS Core Network)

# Look for extra Qt modules wanted by some TelegramQt components
foreach(module ${_WANTED_COMPONENTS})
    if(${module} STREQUAL "Qml")
        list(APPEND QT_COMPONENTS Qml)
    endif()
endforeach()

find_dependency(Qt5 5.6.0 COMPONENTS ${_QT_COMPONENTS})
unset(_QT_COMPONENTS)

# Finally include TelegramQt targets
foreach(module ${_WANTED_COMPONENTS})
    set(module_target "${CMAKE_CURRENT_LIST_DIR}/TelegramQt5${module}Targets.cmake")
    if(EXISTS "${module_target}")
        include("${module_target}")
    endif()

    if(NOT TARGET TelegramQt5::${module})
        if (TelegramQt5_FIND_REQUIRED_${module})
            set(_TelegramQt5_NOTFOUND_MESSAGE
                "${_TelegramQt5_NOTFOUND_MESSAGE}Failed to find TelegramQt5 component \"${module}\"\n")
        elseif(NOT TelegramQt5_FIND_QUIETLY)
            message(WARNING "Failed to find TelegramQt5 component \"${module}\"")
        endif()
    endif()
endforeach()
unset(_WANTED_COMPONENTS)

if (_TelegramQt5_NOTFOUND_MESSAGE)
    set(TelegramQt5_NOT_FOUND_MESSAGE "${_TelegramQt5_NOTFOUND_MESSAGE}")
    set(TelegramQt5_FOUND False)
endif()

# The code below is needed only for backward compatibility and will be removed from the release

# Setup the LIBRARIES variable
get_target_property(TELEGRAM_QT5_LIBRARIES
    TelegramQt5::Core
    IMPORTED_LOCATION
)

if(NOT TELEGRAM_QT5_LIBRARIES)
    # If there is no default IMPORTED_LOCATION then get all configurations...
    get_target_property(_IMPORTED_CONFIGURATIONS
        TelegramQt5::Core
        IMPORTED_CONFIGURATIONS
    )
    # ... and pick up the first one
    list(GET _IMPORTED_CONFIGURATIONS 0 _SELECTED_CONFIGURATION)
    get_target_property(TELEGRAM_QT5_LIBRARIES
        TelegramQt5::Core
        IMPORTED_LOCATION_${_SELECTED_CONFIGURATION}
    )
    unset(_IMPORTED_CONFIGURATIONS)
    unset(_SELECTED_CONFIGURATION)
endif()

# Setup the INCLUDE_DIR variable
get_target_property(TELEGRAM_QT5_INCLUDE_DIR
    TelegramQt5::Core
    INTERFACE_INCLUDE_DIRECTORIES
)
